//+------------------------------------------------------------------+
//|                                           e-FiboBars2c_1_ZZZ.mq4 |
//|                                      Copyright  2011, ZZZEROXXX |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#define MAGICMA  159753456258

extern double Lots               = 0.1;
extern string SLTPStr            = "=== StopLoss && Takeprofit, ignore if 0 ===";
extern double StopLoss           = 0;
extern double TakeProfit         = 0;
extern string MM                 = "===Money management params===";
extern bool UseMM                = false;
extern double MaximumRisk        = 0.02;
extern double DecreaseFactor     = 3;
extern string IndParams1         = "===FiboBars2c_1_ params===";
extern int    period             = 10;
extern int    FiboLevel          = 1;
extern bool AlertMode            = false;

double redbuf=0;
double greenbuf=0;

bool buycond=false;
bool sellcond=false;

bool closebuycond=false;
bool closesellcond=false;

double TP=0;
double SL=0;

int lastOP=0;


bool EnableSells()
{
if (redbuf>greenbuf) return(true); else return(false);
}

bool EnableBuys()
{
if (greenbuf>redbuf) return(true); else return(false);
}


void Calculate()
{
redbuf=iCustom(Symbol(),0,"FiboBars2c_1_",period,FiboLevel,AlertMode,0,1);
greenbuf=iCustom(Symbol(),0,"FiboBars2c_1_",period,FiboLevel,AlertMode,1,1);


//==============================  ================================================
if (EnableBuys()==true && (lastOP==0 || lastOP==-1)) {buycond=true; sellcond=false;} 
if (EnableSells()==true && (lastOP==0 || lastOP==1)) {buycond=false; sellcond=true;}

if (EnableBuys()==true) {closesellcond=true; closebuycond=false;}
if (EnableSells()==true) {closebuycond=true; closesellcond=false;}

}


int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
   if(buys>0) return(buys);
   else       return(-sells);
  }

double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   if(lot<0.1) lot=0.1;
   if (UseMM==true) return(lot); else return(Lots);
  }



void CheckForOpen()
  {
   int    res;
//---- sell conditions
   if(sellcond==true)  
     {
      if (StopLoss!=0) SL=Bid+(NormalizeDouble(Point*StopLoss,Digits)); else SL=0;
      if (TakeProfit!=0) TP=Bid-(NormalizeDouble(Point*TakeProfit,Digits)); else TP=0;
      
      res=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,3,SL,TP,"",MAGICMA,0,Red);
      lastOP=-1;
      sellcond=false;
      return;
     }
//---- buy conditions
   if(buycond==true)  
     {
      if (StopLoss!=0) SL=Ask-(NormalizeDouble(Point*StopLoss,Digits)); else SL=0;
      if (TakeProfit!=0) TP=Ask+(NormalizeDouble(Point*TakeProfit,Digits)); else TP=0;
      
      res=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,SL,TP,"",MAGICMA,0,Blue);
      lastOP=1;
      buycond=false;
      return;
     }
//----
  }


void CheckForClose()
  {
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if(closebuycond==true) {OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
         closebuycond=false; buycond=false; lastOP=0;}
         break;
        }
      if(OrderType()==OP_SELL)
        {
         if(closesellcond==true) {OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
         closesellcond=false; sellcond=false; lastOP=0;}
         break;
        }
     }

}

void start()
  {
   if(Bars<100 || IsTradeAllowed()==false) return;
   Calculate();
   
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else 
   {
   CheckForClose();
   }
   
   
//----
  }
//+------------------------------------------------------------------+